//---------------------------------------------------------------------------
#ifndef PasswdDlgH
#define PasswdDlgH
//---------------------------------------------------------------------------
#include <vcl\ComCtrls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ExtCtrls.hpp>

#include "PGPpassEx.h"
//---------------------------------------------------------------------------
// Keys is a list of key ids, current key tells dialog which to make current. After
// call current key indicated the key the phrase belongs to.
//bool __fastcall PGPgetKeyidAndPassphrase(TStrings *Keys, int &CurrentKey,
//   AnsiString &Phrase, TForm* MainForm);
//bool __fastcall PGPgetConventionalPassphrase(AnsiString &Phrase);
//bool __fastcall PGPgetDecryptionPassphrase(AnsiString &Phrase);

// on entry CancelMode tells dialog to show 'clear secure mode' button. on exit it
// tells if the user wants to cancel secure mode.
//bool __fastcall PGPgetSecureModePassphrase(bool &CancelMode, AnsiString &Phrase);

//enum PasswdMode { mConventionalPhrase, mSignKeyPhrase, mDecryptionPhrase, mSecureModePhrase };
class TPasswordDlg : public TForm
{
__published:	// IDE-managed Components
  TLabel *Label1;
  TComboBox *Keyid;
  TCheckBox *HideTypeBox;
  TLabel *Label2;
  TButton *OkBtn;
  TButton *CancelBtn;
  TMemo *Cnfrm;
  TMemo *Phrase;
  TLabel *Label3;
  TGroupBox *QualityBox;
  TProgressBar *ProgressBar1;
  TButton *ClearModeBtn;
  TTimer *Timer1;
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall HideTypeBoxClick(TObject *Sender);
  void __fastcall FormDestroy(TObject *Sender);
  void __fastcall PhraseChange(TObject *Sender);
  void __fastcall FormShow(TObject *Sender);
  void __fastcall ClearModeBtnClick(TObject *Sender);
private:	// User declarations
  void __fastcall ClearText();
  void __fastcall SetMode(PassMode Mode);
  void __fastcall Reset();
public:		// User declarations
  bool *HideType;
  PassMode FormMode;
  virtual __fastcall TPasswordDlg(TComponent* Owner);
  virtual __fastcall TPasswordDlg(TComponent* Owner, PassMode Mode);
  char* __fastcall GetSignKeyAndPassphrase(TStrings *Keys, int &CurrentKey);
};

//---------------------------------------------------------------------------
extern TPasswordDlg *PasswordDlg;
//---------------------------------------------------------------------------
#endif
