//---------------------------------------------------------------------------
// MixDir() is in global.cpp
#include <vcl\vcl.h>
#pragma hdrstop

#include "PgpDlg.h"
#include "Pgpfiles.h"
#include "Global.h"
#include "Wiper.h"
#include "pgp.h"
#include "Mixmaster.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPgpForm *PgpForm;
//---------------------------------------------------------------------------
__fastcall TPgpForm::TPgpForm(TComponent* Owner)
  : TForm(Owner)
{
   TheRecips = new TStringList();
// TheText = new TStringList();
   ProgressBar = NULL;
   Feedback = NULL;
   Messages = NULL;
}
//---------------------------------------------------------------------------
__fastcall TPgpForm::TPgpForm(AnsiString PubRing, AnsiString SecRing, AnsiString RemRing,
   TForm* Owner) : TForm(Owner)
{
   dat = buf_new(); pas = buf_new(); enc = buf_new(); sig = buf_new();
   dat->sensitive = pas->sensitive = enc->sensitive = sig->sensitive = true;
   PKeyRing = PubRing; SKeyRing = SecRing; RKeyRing = RemRing;
   TheRecips = new TStringList();
   Topper = new TStringList();
   //TheText = new TStringList();
   MainForm = (TForm*)Owner;
   ClearSign = false;
   ToRemailer = false;
   ProgressBar = NULL;
   Feedback = NULL;
   Messages = NULL;
}
//---------------------------------------------------------------------------
__fastcall TPgpForm::~TPgpForm()
{
   delete Topper;
   delete TheRecips;
   buf_free(pas);
   buf_free(dat);
   buf_free(enc);
}
//---------------------------------------------------------------------------
bool __fastcall TPgpForm::IsRemailed(TStrings *Recips)
{
   AnsiString uid;
   bool remail=false;
   TPgpDb *db = new TPgpDb(RKeyRing,"");
   TPgpKey *pgpkey = db->FirstKey();
   while (!remail && pgpkey)
   {
      for (int i=0; i<pgpkey->UserIds->Count; i++)
      {
         uid = pgpkey->UserIds->Strings[i];
         for (int n=0; n<Recips->Count; n++)
         {
            if (uid.Pos(Recips->Strings[n])>0) remail=true;
            if (remail) break;
         }
         if (remail) break;
      }
      pgpkey = pgpkey->Next;
   }
   delete db;
   return remail;
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::SignMessage(TStrings *Message, AnsiString &SigId,
   AnsiString &passphrase)
{
   int pos;
   AnsiString line,text;
   Caption = "Pgp Sign";  Sleep(100);
   Cap = "...signing message..."; Label1->Caption = Cap;
   buf_sets(pas,passphrase.c_str()); ClearString(passphrase);
   buf_sets(sig,SigId.c_str());
//sm("sig "+String((char*)sig->data));
   Application->ProcessMessages();

   if (ToRemailer)
   {
      text = Message->Text;
      if ((pos=text.Pos("\r\n\r\n"))==text.Pos("\r\n\r\n::\r\n")) text.Delete(pos,2);
      if ((pos=text.Pos("\r\n\r\n"))==text.Pos("\r\n\r\n##\r\n")) text.Delete(pos,2);
      Message->Text = text;
   }
   for (int i=0; i<Message->Count; i++)
      buf_appends(dat,AnsiString(Message->Strings[i]+"\n").c_str());
   switch (Execute(mPGPsign))
   {
      case PGP_OK : Message->SetText((char*)dat->data); break;
      case PGP_ERR: PGPerror("Specified signing key not found!"); break;
      default: PGPerror("PGP signing error: "+AnsiString(Result));
   }
   if (ToRemailer)
   {
      text = Message->Text;
      if ((pos=text.Pos("\r\n::\r\n"))>0) text.Insert("\r\n",pos);
      if ((pos=text.Pos("\r\n##\r\n"))>0) text.Insert("\r\n",pos);
      Message->Text = text;
   }

   if (Result!=PGP_OK) ModalResult = mrCancel;
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::EncryptCMessage(TStrings *Message, AnsiString &Passphrase)
{
   Caption = "Pgp Encrypt"; Sleep(100);
   Cap = "...encrypting message...";
   Label1->Caption = Cap;
   Application->ProcessMessages();
   for (int i=0; i<Message->Count; i++)
      buf_appends(dat,AnsiString(Message->Strings[i]+"\n").c_str());
   buf_appends(enc,Passphrase.c_str()); ClearString(Passphrase);
   switch (Execute(mPGPencryptc))
   {
      case PGP_OK  : Message->Text = (char*)dat->data; break;
      case PGP_ERR : PGPerror("Specified key not found!"); break;
      case PGP_PASS: PGPerror("Bad signature passphrase!"); break;
      default: PGPerror("PGP encrypt error: "+AnsiString(Result));
   }
   if (Result!=PGP_OK) ModalResult = mrCancel;
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::EncryptMessage(TStrings *Message, TStrings *Recips)
{
   int i;
   Caption = "Pgp Encrypt"; Sleep(100);
   Cap = "...encrypting message...";
   Label1->Caption = Cap;
   Application->ProcessMessages();

   bool IsRemailer = Recips->Text.Pos(RKeyRing)>0;
//sm(s(IsRemailer?"true \n":"false \n")+RKeyRing);
   for (i=0; i<Message->Count; i++)
      buf_appends(dat,AnsiString(Message->Strings[i]+"\n").c_str());
   for (i=0; i<Recips->Count; i++)
      buf_appends(enc,AnsiString(GetParam(0,Recips->Strings[i],"\255")+"\n").c_str());
   switch (Execute(mPGPencrypt))
   {
      case PGP_OK  : Message->Text = AnsiString((char*)dat->data); break;
      case PGP_ERR : PGPerror("Specified public key not found!"); break;
      case PGP_PASS: PGPerror("Bad signature passphrase!"); break;
      default: PGPerror("PGP encrypt error: "+AnsiString(Result));
   }
   if (Result==PGP_OK && IsRemailer) Message->Insert(0,"::\r\nEncrypted: PGP\r\n");
   if (Result!=PGP_OK) ModalResult = mrCancel;

   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::EncryptSignMessage(TStrings *Message, AnsiString &SigId,
   AnsiString &Passphrase, TStrings *Recips, bool Clearsign)
{
   int i;
   AnsiString line;
   Caption = "Pgp Sign Encrypt"; Sleep(100);
   Cap = "...encrypting message..."; Label1->Caption = Cap;
   Application->ProcessMessages();

   ClearSign = Clearsign;
   for (i=0; i<Message->Count; i++)
      buf_appends(dat,AnsiString(Message->Strings[i]+"\n").c_str());
   for (i=0; i<Recips->Count; i++)
      buf_appends(enc,AnsiString(GetParam(0,Recips->Strings[i],"\255")+"\n").c_str());
   buf_sets(pas,Passphrase.c_str()); ClearString(Passphrase);
   buf_sets(sig,SigId.c_str());
   switch (Execute(mPGPencryptsign))
   {
      case PGP_OK  : Message->Text = AnsiString((char*)dat->data); break;
      case PGP_ERR : PGPerror("Specified public key not found!"); break;
      case PGP_PASS: PGPerror("Bad signature passphrase!"); break;
      default: PGPerror("PGP encrypt error: "+AnsiString(Result));
   }
   if (Result==PGP_OK && ToRemailer) Message->Insert(0,"::\r\nEncrypted: PGP\r\n");
   if (Result!=PGP_OK) ModalResult = mrCancel;
   return Result;
}
//---------------------------------------------------------------------------
char* __fastcall PoundString(int length)
{
   AnsiString poundline =
      s("#####################################################################")+
      s("###################################################################\n");
   return poundline.SubString(poundline.Length()-length,length+1).c_str();
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::DecryptMessage(BUFFER *Message, AnsiString &Passphrase)
{
   AnsiString line;
   Caption = "Pgp Decrypt"; Sleep(100);
   Cap = "...decrypting message..."; Label1->Caption = Cap;
   Application->ProcessMessages();

   buf_set(dat,Message);
   buf_sets(pas,Passphrase.c_str()); ClearString(Passphrase);
   buf_clear(sig);
   int minwide=58;
   switch (Execute(mPGPdecrypt))
   {
      case PGP_OK: buf_set(Message,dat); break;
      case PGP_ERR: PGPerror("The message can't be read."); break;
      case PGP_PASS: PGPerror("Bad passphrase."); break;
      case PGP_NOMSG: PGPerror("Message is not an OpenPGP message."); break;
      case PGP_NODATA: PGPerror("OpenPGP message does not contain user data."); break;
      case PGP_SIGOK:
         buf_sets(Message,PoundString(sig->length<minwide-6 ? minwide:sig->length+6));    //"##################################");
         buf_appends(Message,"# "); buf_cat(Message,sig); buf_appendc(Message,'\n');
         buf_appends(Message,"# Digital Signature OK\n\n");
         buf_cat(Message,dat);
         break;
      case PGP_SIGBAD:
         buf_sets(Message,PoundString(sig->length<minwide-10 ? minwide:sig->length+10));    //"##################################");
         buf_appends(Message,"# Key "); buf_cat(Message,sig); buf_appendc(Message,'\n');
         buf_appends(Message,"# Verify FAILED, bad digital signature\n\n");
         buf_cat(Message,dat);
         break;
      case PGP_SIGNKEY:
         buf_sets(Message,PoundString(minwide));
         buf_appends(Message,"# Unknown key "); buf_cat(Message,sig); buf_appends(Message,", Can't verify digital signature\n\n");
         buf_cat(Message,dat);
         break;
   }
   if (Result!=PGP_OK && Result!=PGP_SIGOK && Result!=PGP_SIGBAD && Result!=PGP_SIGNKEY)
      ModalResult = mrCancel;
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::VerifyMessage(BUFFER *Message, BUFFER *Sig)
{
   AnsiString line,id;
   Caption = "Pgp Verify"; Sleep(100);
   Cap = "...checking signature..."; Label1->Caption = Cap;
   TStringList *tmp = new TStringList();
   Application->ProcessMessages();
   buf_set(dat,Message);
   buf_set(sig,Sig);
   int minwide=58;
/*//==========================================================
      //AnsiString tmp1,tmp,str = msg->Text;
      //int pos = str.Pos("-----BEGIN");
      //str.Delete(1,pos-1);
      TStringList *t = new TStringList();
      for (int i=1; i<dat->length; i++)
      {
         AnsiString tmp1 = s((byte)dat->data[i]);
         while (tmp1.Length()<6) tmp1 = " "+tmp1;

         AnsiString tmp = s((char)dat->data[i]);
         if (dat->data[i]==10) tmp = "\\10";
         if (dat->data[i]==13) tmp = "\\13";
         while (tmp.Length()<6) tmp = " "+tmp;

         t->Add(tmp1+tmp);
      }
      t->SaveToFile("temp.1.txt");
      delete t;
*///=========================================================
//sm(s("bef dat")+s((char*)dat->data));
//sm(s("bef sig")+s((char*)sig->data));
   switch (Execute(mPGPverify))
   {
      case PGP_OK: buf_set(Message,dat); break;
      case PGP_ERR: PGPerror("The message can't be read."); break;
      case PGP_PASS: PGPerror("Bad passphrase."); break;
      case PGP_NOMSG: PGPerror("Message is not an OpenPGP message."); break;
      case PGP_NODATA: PGPerror("OpenPGP message does not contain user data."); break;
      case PGP_SIGOK:
         buf_sets(Message,PoundString(sig->length<minwide-6 ? minwide:sig->length+6));    //"##################################");
         buf_appends(Message,"# "); buf_cat(Message,dat); buf_appendc(Message,'\n');
         buf_appends(Message,"# Digital Signature OK\n\n");
         buf_cat(Message,sig);
         break;
      case PGP_SIGBAD:

//sm(s("aft dat")+s((char*)dat->data));
//sm(s("aft sig")+s((char*)sig->data));
         buf_sets(Message,PoundString(sig->length<minwide-10 ? minwide:sig->length+10));    //"##################################");
         buf_appends(Message,"# Key "); buf_cat(Message,sig); buf_appendc(Message,'\n');
         buf_appends(Message,"# Verify FAILED, bad digital signature\n#\n\n");
         buf_cat(Message,dat);
         break;
      case PGP_SIGNKEY:
         tmp->SetText((char*)sig->data);
         sm(tmp->Text);
         if (tmp->Count)
         {
            id = tmp->Strings[tmp->Count-1];
            if (!id.IsEmpty()) id = " 0x"+id;
            tmp->Delete(tmp->Count-1);
            buf_sets(sig,tmp->Text.c_str());
         }
         buf_sets(Message,PoundString(minwide));
         buf_appends(Message,"# Unknown key"); buf_appends(Message,id.c_str());
         buf_appends(Message,", Can't verify digital signature\n");
         buf_appends(Message,"#\n");
         buf_cat(Message,sig);
         break;
   }
//TStringList *t = new TStringList();
//t->SetText((char*)dat->data);
//sm(t->Text);
//delete t;
   if (Result!=PGP_OK && Result!=PGP_SIGOK && Result!=PGP_SIGBAD && Result!=PGP_SIGNKEY)
      ModalResult = mrCancel;
   delete tmp;
   return Result;
}
//---------------------------------------------------------------------------
void __fastcall TPgpForm::Timer1Timer(TObject *Sender)
{
   int pos;
   TPgpDb *db;
   AnsiString tmpname=MixDir()+"pubring.pkr.tmp";
   Timer1->Enabled = false;
   Timer2->Enabled = true;
   Label1->Caption = Cap;
   Application->ProcessMessages();
   TStringList *msg = new TStringList();
   switch (Mode)
   {
      case mPGPverify:
sm(s("bef dat")+s((char*)dat->data));
sm(s("bef sig")+s((char*)sig->data));
         Result = pgp_decrypt(dat,NULL,sig,PKeyRing.c_str(),NULL);
sm(s("aft dat")+s((char*)dat->data));
sm(s("aft sig")+s((char*)sig->data));
         break;
      case mPGPdecrypt:
         Result = pgp_decrypt(dat,pas,sig,PKeyRing.c_str(),SKeyRing.c_str());
         break;
      case mPGPsign:
         //sm("sec "+SKeyRing);
         Result = pgp_mailenc(PGP_SIGN,dat,(char*)sig->data,pas,NULL,SKeyRing.c_str());
         break;
      case mPGPencrypt:
         db = new TPgpDb(PgpPublicRing()+"\n"+PgpRemailRing(),"");
         db->SaveToFile(tmpname);
         Result = pgp_encrypt(PGP_ENCRYPT|PGP_TEXT,dat,enc,NULL,NULL,
            tmpname.c_str(), NULL);
         simplewipe(tmpname);
         delete db;
         break;
      case mPGPencryptc:
         Result = pgp_encrypt(PGP_CONVENTIONAL|PGP_TEXT,dat,enc,NULL,NULL,NULL,NULL);
         break;
      case mPGPencryptsign:
         //Result = pgp_encrypt(PGP_ENCRYPT|PGP_SIGN|PGP_TEXT,dat,enc,sig,pas,
         //   PKeyRing.c_str(),SKeyRing.c_str());
         db = new TPgpDb(PKeyRing+"\n"+RKeyRing,"");
         db->SaveToFile(tmpname);
         if (ClearSign)
         {
            if (ToRemailer)
            {
               AnsiString text = (char*)dat->data;
               if ((pos=text.Pos("\n\n##\n"))>0) text.Delete(pos,1);
               msg->Text = text; text = ""; buf_clear(dat);
               for (int i=0; i<msg->Count; i++)
                  buf_appends(dat,AnsiString(msg->Strings[i]+"\n").c_str());
               msg->Clear();
            }
            Result = pgp_mailenc(PGP_SIGN,dat,(char*)sig->data,pas,NULL,SKeyRing.c_str());
            if (ToRemailer)
            {
               AnsiString text = (char*)dat->data;
               if ((pos=text.Pos("\n##\n"))>0) text.Insert("\n",pos);
               msg->Text = text; text = ""; buf_clear(dat);
               for (int i=0; i<msg->Count; i++)
                  buf_appends(dat,AnsiString(msg->Strings[i]+"\n").c_str());
               msg->Clear();
            }
            if (Result==PGP_OK)
            {
               Result = pgp_encrypt(PGP_ENCRYPT|PGP_TEXT|PGP_REMAIL,dat,enc,NULL,NULL,
                  tmpname.c_str(), NULL);
            }
         }
         else
         {
            Result = pgp_encrypt(PGP_ENCRYPT|PGP_SIGN|PGP_TEXT|PGP_REMAIL,dat,enc,sig,pas,
               tmpname.c_str(), SKeyRing.c_str());
         }
         simplewipe(tmpname);
         delete db;
         break;
   }
   delete msg;
   Timer2->Enabled = false; Sleep(100); if (Mode!=mPGPverify) Sleep(100);
   Hide(); AppProcessMessages(); Sleep(100); if (Mode!=mPGPverify) Sleep(100);
   if (ModalResult==mrNone) ModalResult=mrOk;
 }
//---------------------------------------------------------------------------
/*int __fastcall PgpEncryptMessage(TStringList *Msg, TStringList *Recips,const AnsiString &PKeyRing)
{
   PgpForm = new TPgpForm(Application->MainForm);
   PgpForm->Cap = "...encrypting message...";
   PgpForm->Recips = Recips;
   PgpForm->PKeyRing = PKeyRing;
   PgpForm->Message->Text = Msg->Text;
   PgpForm->Mode = modePgpEncryptMessage;
   PgpForm->Caption = "Pgp";
   PgpForm->ShowModal();
   int ret = PgpForm->ModalResult;
   if (PgpForm->Result!=0) ret = mrCancel;
   if (ret==mrOk) Msg->Text = PgpForm->Message->Text;
   delete PgpForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall PgpDecryptConventional(TStringList *Data, TDataBuf *Passphrase)
{
   PgpForm = new TPgpForm(Application->MainForm);
   PgpForm->Cap = "...decrypting message...";
   PgpForm->Message->Text = Data->Text;
   PgpForm->Mode = modePgpDecryptConventional;
   PgpForm->Caption = "Pgp";
   Passphrase->Decrypt(BUFWORD);
   PgpForm->Password = Passphrase; PgpForm->ShowModal();
   Passphrase->Encrypt(BUFWORD);
   int ret = PgpForm->ModalResult;
   if (PgpForm->Result!=0) ret = mrCancel;
   if (ret==mrOk) Data->Text = PgpForm->Message->Text;
   delete PgpForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall PgpEncryptSignMessage(TStringList *Msg, TStringList *Recips, const AnsiString &SigId,
   TDataBuf *Password, const AnsiString &PKeyRing, const AnsiString &SKeyRing)
{
   PgpForm = new TPgpForm(Application->MainForm);
   PgpForm->Cap = "...encrypt/signing...";
   PgpForm->SigId = SigId;
   PgpForm->Recips = Recips;
   PgpForm->PKeyRing = PKeyRing;
   PgpForm->SKeyRing = SKeyRing;
   PgpForm->Message->Text = Msg->Text;
   PgpForm->Mode = modePgpEncryptSignMessage;
   PgpForm->Caption = "Pgp";
   Password->Decrypt(BUFWORD);
   PgpForm->Password = Password; PgpForm->ShowModal();
   Password->Encrypt(BUFWORD);
   int ret = PgpForm->ModalResult;
   if (PgpForm->Result!=0) ret = mrCancel;
   if (ret==mrOk) Msg->Text = PgpForm->Message->Text;
   delete PgpForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall PgpEncryptFile(TDataBuf *Password, AnsiString &Filename, AnsiString &Ext)
{
   PgpForm = new TPgpForm(Application->MainForm);
   PgpForm->Cap = "...encrypting "+ExtractFileName(AppDat.LowerCase())+"...";
   PgpForm->Filename = Filename;//.LowerCase();
   PgpForm->NewExt = Ext;
   PgpForm->Mode = modePgpEncryptFile;
   PgpForm->Caption = "Pgp";
   Password->Decrypt(BUFWORD);
   PgpForm->Password = Password; PgpForm->ShowModal();
   Password->Encrypt(BUFWORD);
   int ret = PgpForm->ModalResult;
   if (PgpForm->Result!=0) ret = mrCancel;
   delete PgpForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall PgpDecryptFile(TDataBuf *Password, AnsiString &Filename, AnsiString &Ext)
{
   PgpForm = new TPgpForm(Application->MainForm);
   PgpForm->Cap = "...decrypting "+ExtractFileName(AppPgp.LowerCase())+"...";
   PgpForm->Filename = Filename;//.LowerCase();
   PgpForm->NewExt = Ext;
   PgpForm->Mode = modePgpDecryptFile;
   PgpForm->Caption = "Pgp";
   Password->Decrypt(BUFWORD);
   PgpForm->Password = Password;
   PgpForm->ShowModal();
   Password->Encrypt(BUFWORD);
   int ret = PgpForm->ModalResult;
   if (PgpForm->Result!=0) ret = mrCancel;
   delete PgpForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall MixConfigNym(TDataBuf *Password, TStrings *message, TComponent *Owner)
{
   PgpForm = new TPgpForm(Owner);
   PgpForm->Cap = "  Encrypting Nym Config...";
   PgpForm->Message = message;
   PgpForm->Mode = modeMixConfigNym;
   PgpForm->Caption = "Mixmaster";
   Password->Decrypt(BUFWORD);
   PgpForm->Password = Password; PgpForm->ShowModal();
   Password->Encrypt(BUFWORD);
   int ret = PgpForm->ModalResult;
   if (PgpForm->Result!=0) ret = mrCancel;
   delete PgpForm;
   return ret;
}
//---------------------------------------------------------------------------
__fastcall TPgpForm::TPgpForm(TComponent* Owner)
  : TForm(Owner)
{
   Position = poScreenCenter;
   if (Application->MainForm)
   {
      Position = poDesigned;
      TForm *Main = Application->MainForm;
      Top = Main->Top+((Main->Height-Height)/2);
      Left = Main->Left+((Main->Width-Width)/2);
   }
   ProgressBar = NULL;
   Feedback = NULL;
   Messages = NULL;
   Message = new TStringList();
}
*/
//---------------------------------------------------------------------------
void __fastcall TPgpForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
/*
   switch (Mode)
   {
      case modePgpEncryptFile:
      {
         AnsiString pgpname = ChangeFileExt(Filename,PgpExt);
         if (ModalResult==mrCancel && FileExists(pgpname))
            remove(pgpname.c_str());
         break;
      }
      case modePgpDecryptFile:
      {
         AnsiString datname = ChangeFileExt(Filename,DatExt);
         if (ModalResult==mrCancel && FileExists(datname))
            remove(datname.c_str());
         break;
      }
   }
   Sleep(500);
*/
}
int __fastcall TPgpForm::PgpEncryptSignMessage()
{
/*
   BUFFER *dat = buf_new(), *enc = buf_new(), *sig = buf_new(), *pas = buf_new();
   dat->sensitive = enc->sensitive = sig->sensitive = pas->sensitive = true;
   Application->ProcessMessages();
   buf_append(enc,(byte*)Recips->Text.c_str(),Recips->Text.Length());
   buf_append(dat,(byte*)TheText->Text.c_str(),TheText->Text.Length());
   buf_append(sig,(byte*)SigId.c_str(),SigId.Length());
   buf_append(pas,(byte*)Password->data,Password->length);
   Result = pgp_encrypt(PGP_SIGN|PGP_ENCRYPT|PGP_TEXT,dat,enc,sig,pas,
      PKeyRing.c_str(),SKeyRing.c_str());
   switch (Result)
   {
      case PGP_PASS: MsgBoxHwnd(Handle,"Bad signature passphrase!","PGP Error",MB_OK); break;
      case -1: MsgBoxHwnd(Handle,"Specified key not found!","PGP Error",MB_OK); break;
      case  0: TheText->Text = AnsiString((char*)dat->data); break;
      default:
         MsgBoxHwnd(Handle,"PGP encrypt/sign error: "+AnsiString(Result),"PGP Error",MB_OK);
   }
   Application->ProcessMessages();
   buf_free(pas); buf_free(sig); buf_free(enc); buf_free(dat);
*/
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::PgpDecryptConventional()
{
   BUFFER *dat = buf_new(), *pas = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   Application->ProcessMessages();

//   Password->Decrypt(BUFWORD);
//   buf_append(pas,(byte*)Password->data,Password->length);
//   Password->Encrypt(BUFWORD);

   buf_append(dat,(byte*)TheText->Text.c_str(),TheText->Text.Length());
   Result = pgp_decrypt(dat,pas,NULL,NULL,NULL);
   if (!Result) TheText->SetText((char*)dat->data);

   Application->ProcessMessages();
   buf_free(pas); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::PgpEncryptFile()
{
   BUFFER *dat = buf_new(), *pas = buf_new(), *enc = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   Application->ProcessMessages();
//   Password->Decrypt(BUFWORD);
   buf_appends(pas,Passphrase->c_str());
//   Password->Encrypt(BUFWORD);
   buf_readfile(dat,Filename.c_str());
   Result = pgp_encrypt(PGP_CONVENTIONAL|PGP_NOARMOR,dat,pas,NULL,enc,NULL,NULL);
   if (!Result) buf_writefile(dat,ChangeFileExt(Filename,NewExt).c_str(),"wb");

   Application->ProcessMessages();
   buf_free(enc); buf_free(pas); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::PgpDecryptFile()
{
   BUFFER *dat = buf_new(), *pas = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   Application->ProcessMessages();
   //Password->Decrypt(BUFWORD);
   buf_appends(pas,Passphrase->c_str());
   //Password->Encrypt(BUFWORD);
   buf_readfile(dat,Filename.c_str());
   Result = pgp_decrypt(dat,pas,NULL,NULL,NULL);
   if (!Result) buf_writefile(dat,ChangeFileExt(Filename,NewExt).c_str(),"wb");

   Application->ProcessMessages();
   buf_free(pas); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
/*void __fastcall TPgpForm::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   Label1->Caption = Cap;
   switch (Mode)
   {
//      case modePgpEncryptFile: PgpEncryptFile(); break;
//      case modePgpDecryptFile: PgpDecryptFile(); break;
      case modePgpSignMessage: PgpSignMessage(); break;
      case modePgpEncryptMessage: PgpEncryptMessage(); break;
      case modePgpEncryptSignMessage: PgpEncryptSignMessage(); break;
//      case modePgpEncryptConventional: PgpEncryptConventional(); break;
//     case modePgpDecryptConventional: PgpDecryptConventional(); break;
   }
   Application->ProcessMessages();
   if (ModalResult == mrNone)
       ModalResult = mrOk;
 }*/
//---------------------------------------------------------------------------
void __fastcall TPgpForm::Timer2Timer(TObject *Sender)
{
   if (Label1->Caption.IsEmpty()) Label1->Caption = Cap;
   else Label1->Caption = "";
}
//---------------------------------------------------------------------------
void __fastcall TPgpForm::Timer3Timer(TObject *Sender)
{
/*   ProgressBar->Position += (WORD)1;
   if (*Cancelled && ProgressBar->Position<100)
   {
      int start = ProgressBar->Position;
      for (int i=start; i<=100; i++)
      {
         ProgressBar->Position += (WORD)1;
         Application->ProcessMessages();
         Sleep(1);
      }
      Timer3->Enabled = false;
      ModalResult = mrCancel;
   }
*/
}
//---------------------------------------------------------------------------
void __fastcall TPgpForm::FormShow(TObject *Sender)
{
   CenterDialog(this,MainForm);
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::Execute(int mode)
{
   Mode = mode; ShowModal(); return Result;
}
//---------------------------------------------------------------------------
void __fastcall TPgpForm::PGPerror(AnsiString &errorStr, AnsiString title)
{
   MsgBoxHwnd(Handle,errorStr,title,MB_OK);
}
//---------------------------------------------------------------------------








