//---------------------------------------------------------------------------
#ifndef pgpmailH
#define pgpmailH
//---------------------------------------------------------------------------
bool  __fastcall HasPgp();
AnsiString __fastcall PgpDir();
AnsiString __fastcall PgpPublicRing();
AnsiString __fastcall PgpSecretRing();
AnsiString __fastcall PgpRemailRing();

const AnsiString __fastcall ClrTextHdr = "Clear-Text: ";

int  __fastcall QSPoolNext();
void __fastcall QSPoolClear();
int  __fastcall QSPoolCount();
int  __fastcall QSPoolAdd(TStrings *Msg, AnsiString &Name);
int  __fastcall QSPoolRemove(AnsiString &Name);
int  __fastcall QSPoolGet(TStrings *Msg, AnsiString &Name, bool Remove=true);
const AnsiString QSPoolKey = "QSPoolKey";
bool __fastcall QSPoolClearTextToHeader(TStrings *msg, int ClearText);
bool __fastcall QSPoolHeaderToClearText(int &ClearText, TStrings *msg);

void  __fastcall PgpInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, TForm *MainForm,
   HWND AppHandle);
char* __fastcall PgpSignMessage(char *Message);
char* __fastcall PgpEncryptMessage(char *Message);
char* __fastcall PgpEncryptSignMessage(char *Message);
char* __fastcall PgpDecryptVerifyMessage(char *Message);
char* __fastcall PgpVerifyMessage(char *Message);
char* __fastcall GetPgpLibVersion();
char* __fastcall GetPgpLibName();
char* __fastcall PgpGetNewRemailerKeys(char *KeyDoc, char *Type1);
char* __fastcall PgpAddNewRemailerKeys(char *KeyDoc, char *Type1);
char* __fastcall PgpArmorKeysToArmorBlock(char *Keys);
char* __fastcall PgpArmorBlockToArmorKeys(char *Keys);
char* __fastcall PgpGetUserIdsKeyIds(char *KeyFile);
bool  __fastcall PgpImportKeysReplace(char *importfile, char *pubring,
   char *secring, bool deleteImportfile);
bool  __fastcall PgpImportKeysAddNew(char *importfile, char *pubring,
   char *secring, bool deleteImportfile);
bool  __fastcall PgpIsConventional(char* Message);

typedef void  __fastcall (*PGPINIT)(HINSTANCE, HINSTANCE, TForm*, HWND);
typedef char* __fastcall (*PGP_SIGNMESSAGE)(char*);
typedef char* __fastcall (*PGP_ENCRYPTMESSAGE)(char*);
typedef char* __fastcall (*PGP_ENCRYPTSIGNMESSAGE)(char*);
typedef char* __fastcall (*PGP_DECRYPTVERIFYMESSAGE) (char*);
typedef char* __fastcall (*PGP_VERIFYMESSAGE) (char*);
typedef char* __fastcall (*PGP_GETNEWKEYS)(char*,char*); // remailer keyring
typedef char* __fastcall (*PGP_ADDNEWKEYS)(char*,char*); // remailer keyring
typedef char* __fastcall (*GET_PGPLIBVERSION)();
typedef char* __fastcall (*GET_PGPLIBNAME)();
// translate pubring.asc from a single large keyblock to individual
// ket-blocks and then reverse the same
typedef char* __fastcall (*PGP_PUTARMORKEYS)(char*); // put individually armored keys
typedef char* __fastcall (*PGP_GETARMORKEYS)(char*); // put back single ascii key-block
typedef char* __fastcall (*PGP_GETKEYS_IDS)(char*);
typedef bool  __fastcall (*PGP_IMPORTREPLACE)(char*,char*,char*,bool);
typedef bool  __fastcall (*PGP_IMPORTADDNEW)(char*,char*,char*,bool);
typedef bool  __fastcall (*PGP_ISCONVENTIONAL)(char*);
//---------------------------------------------------------------------------
extern HINSTANCE hPgpLib;
#endif
